import pymel.core as pm
from alShaders import *

class AEalLayerTemplate(alShadersTemplate):
	controls = {}
	params = {}
	def setup(self):
		self.params.clear()
		self.params["layer1"] = Param("layer1", "Layer 1", "The bottom layer to blend.", "rgb", presets=None)
		self.params["layer2"] = Param("layer2", "Layer 2", "The top layer to blend.", "rgb", presets=None)
		self.params["mix"] = Param("mix", "Mix", "The amount to blend from the bottom layer to the top.", "float", presets=None)
		self.params["debug"] = Param("debug", "Debug", "Allows you to quickly preview each layer and the mix value.", "enum", presets=None)
		self.params["standardCompatibleAOVs"] = Param("standardCompatibleAOVs", "Write standard AOVs only", "", "bool", presets=None)
		self.params["aov_diffuse_color"] = Param("aov_diffuse_color", "Diffuse color", "", "rgb", presets=None)
		self.params["aov_direct_diffuse"] = Param("aov_direct_diffuse", "Direct diffuse", "", "rgb", presets=None)
		self.params["aov_direct_diffuse_raw"] = Param("aov_direct_diffuse_raw", "Direct diffuse (raw)", "", "rgb", presets=None)
		self.params["aov_indirect_diffuse"] = Param("aov_indirect_diffuse", "Indirect diffuse", "", "rgb", presets=None)
		self.params["aov_indirect_diffuse_raw"] = Param("aov_indirect_diffuse_raw", "Indirect diffuse (raw)", "", "rgb", presets=None)
		self.params["aov_direct_backlight"] = Param("aov_direct_backlight", "Direct backlight", "", "rgb", presets=None)
		self.params["aov_indirect_backlight"] = Param("aov_indirect_backlight", "Indirect backlight", "", "rgb", presets=None)
		self.params["aov_direct_specular"] = Param("aov_direct_specular", "Direct specular", "", "rgb", presets=None)
		self.params["aov_indirect_specular"] = Param("aov_indirect_specular", "Indirect specular", "", "rgb", presets=None)
		self.params["aov_direct_specular_2"] = Param("aov_direct_specular_2", "Direct specular 2", "", "rgb", presets=None)
		self.params["aov_indirect_specular_2"] = Param("aov_indirect_specular_2", "Indirect specular 2", "", "rgb", presets=None)
		self.params["aov_single_scatter"] = Param("aov_single_scatter", "Single scatter", "", "rgb", presets=None)
		self.params["aov_sss"] = Param("aov_sss", "SSS", "", "rgb", presets=None)
		self.params["aov_refraction"] = Param("aov_refraction", "Refraction", "", "rgb", presets=None)
		self.params["aov_emission"] = Param("aov_emission", "Emission", "", "rgb", presets=None)
		self.params["aov_uv"] = Param("aov_uv", "UV", "", "rgb", presets=None)
		self.params["aov_depth"] = Param("aov_depth", "Depth", "", "rgb", presets=None)
		self.params["aov_light_group_1"] = Param("aov_light_group_1", "Light group [1]", "", "rgb", presets=None)
		self.params["aov_light_group_2"] = Param("aov_light_group_2", "Light group [2]", "", "rgb", presets=None)
		self.params["aov_light_group_3"] = Param("aov_light_group_3", "Light group [3]", "", "rgb", presets=None)
		self.params["aov_light_group_4"] = Param("aov_light_group_4", "Light group [4]", "", "rgb", presets=None)
		self.params["aov_light_group_5"] = Param("aov_light_group_5", "Light group [5]", "", "rgb", presets=None)
		self.params["aov_light_group_6"] = Param("aov_light_group_6", "Light group [6]", "", "rgb", presets=None)
		self.params["aov_light_group_7"] = Param("aov_light_group_7", "Light group [7]", "", "rgb", presets=None)
		self.params["aov_light_group_8"] = Param("aov_light_group_8", "Light group [8]", "", "rgb", presets=None)
		self.params["aov_id_1"] = Param("aov_id_1", "ID [1]", "", "rgb", presets=None)
		self.params["aov_id_2"] = Param("aov_id_2", "ID [2]", "", "rgb", presets=None)
		self.params["aov_id_3"] = Param("aov_id_3", "ID [3]", "", "rgb", presets=None)
		self.params["aov_id_4"] = Param("aov_id_4", "ID [4]", "", "rgb", presets=None)
		self.params["aov_id_5"] = Param("aov_id_5", "ID [5]", "", "rgb", presets=None)
		self.params["aov_id_6"] = Param("aov_id_6", "ID [6]", "", "rgb", presets=None)
		self.params["aov_id_7"] = Param("aov_id_7", "ID [7]", "", "rgb", presets=None)
		self.params["aov_id_8"] = Param("aov_id_8", "ID [8]", "", "rgb", presets=None)
		self.params["aov_shadow_group_1"] = Param("aov_shadow_group_1", "Shadow group [1]", "", "rgba", presets=None)
		self.params["aov_shadow_group_2"] = Param("aov_shadow_group_2", "Shadow group [2]", "", "rgba", presets=None)
		self.params["aov_shadow_group_3"] = Param("aov_shadow_group_3", "Shadow group [3]", "", "rgba", presets=None)
		self.params["aov_shadow_group_4"] = Param("aov_shadow_group_4", "Shadow group [4]", "", "rgba", presets=None)
		self.params["aov_shadow_group_5"] = Param("aov_shadow_group_5", "Shadow group [5]", "", "rgba", presets=None)
		self.params["aov_shadow_group_6"] = Param("aov_shadow_group_6", "Shadow group [6]", "", "rgba", presets=None)
		self.params["aov_shadow_group_7"] = Param("aov_shadow_group_7", "Shadow group [7]", "", "rgba", presets=None)
		self.params["aov_shadow_group_8"] = Param("aov_shadow_group_8", "Shadow group [8]", "", "rgba", presets=None)

		self.addSwatch()
		self.beginScrollLayout()

		self.addCustomRgb("layer1")
		self.addCustomRgb("layer2")
		self.addCustomFlt("mix")
		self.addControl("debug", label="Debug", annotation="Allows you to quickly preview each layer and the mix value.")
		self.beginLayout("AOVs", collapse=True)
		self.addControl("standardCompatibleAOVs", label="Write standard AOVs only", annotation="")
		self.addCustomRgb("aov_diffuse_color")
		self.addCustomRgb("aov_direct_diffuse")
		self.addCustomRgb("aov_direct_diffuse_raw")
		self.addCustomRgb("aov_indirect_diffuse")
		self.addCustomRgb("aov_indirect_diffuse_raw")
		self.addCustomRgb("aov_direct_backlight")
		self.addCustomRgb("aov_indirect_backlight")
		self.addCustomRgb("aov_direct_specular")
		self.addCustomRgb("aov_indirect_specular")
		self.addCustomRgb("aov_direct_specular_2")
		self.addCustomRgb("aov_indirect_specular_2")
		self.addCustomRgb("aov_single_scatter")
		self.addCustomRgb("aov_sss")
		self.addCustomRgb("aov_refraction")
		self.addCustomRgb("aov_emission")
		self.addCustomRgb("aov_uv")
		self.addCustomRgb("aov_depth")
		self.addCustomRgb("aov_light_group_1")
		self.addCustomRgb("aov_light_group_2")
		self.addCustomRgb("aov_light_group_3")
		self.addCustomRgb("aov_light_group_4")
		self.addCustomRgb("aov_light_group_5")
		self.addCustomRgb("aov_light_group_6")
		self.addCustomRgb("aov_light_group_7")
		self.addCustomRgb("aov_light_group_8")
		self.addCustomRgb("aov_id_1")
		self.addCustomRgb("aov_id_2")
		self.addCustomRgb("aov_id_3")
		self.addCustomRgb("aov_id_4")
		self.addCustomRgb("aov_id_5")
		self.addCustomRgb("aov_id_6")
		self.addCustomRgb("aov_id_7")
		self.addCustomRgb("aov_id_8")
		self.addControl("aov_shadow_group_1", label="Shadow group [1]", annotation="")
		self.addControl("aov_shadow_group_2", label="Shadow group [2]", annotation="")
		self.addControl("aov_shadow_group_3", label="Shadow group [3]", annotation="")
		self.addControl("aov_shadow_group_4", label="Shadow group [4]", annotation="")
		self.addControl("aov_shadow_group_5", label="Shadow group [5]", annotation="")
		self.addControl("aov_shadow_group_6", label="Shadow group [6]", annotation="")
		self.addControl("aov_shadow_group_7", label="Shadow group [7]", annotation="")
		self.addControl("aov_shadow_group_8", label="Shadow group [8]", annotation="")
		self.endLayout() # END AOVs

		pm.mel.AEdependNodeTemplate(self.nodeName)
		self.addExtraControls()

		self.endScrollLayout()
